//
//

static gchar *password = NULL;
static GtkWidget *user,
 *passwd,
 *dialog;
static int passwd_caso;

static void
destroy_dialog (GtkWidget * widget, gpointer data) {
    gtk_widget_destroy ((GtkWidget *) data);
    gtk_main_quit ();
}

static void
cancel_dialog (GtkWidget * widget, gpointer data) {
    g_free (password);
    password = NULL;
    gtk_widget_destroy ((GtkWidget *) data);
    gtk_main_quit ();
}

static void
ok_dialog (GtkWidget * widget, gpointer data) {
    char *s,
     *t;
    int caso;

    caso = (int)((long)data);

    s = (char *)gtk_entry_get_text (GTK_ENTRY (user));
    t = (char *)gtk_entry_get_text (GTK_ENTRY (passwd));
    if(!strlen (s))
        s = "Guest";

    g_free (password);
    if(strlen (t) > 0)
        password = g_strdup_printf ("%s%c%s", s, '%', t);
    else
        password = g_strdup_printf ("%s%c", s, '%');

    gtk_widget_destroy (dialog);
    gtk_main_quit ();
}

static void
entry_activate (GtkWidget * entry, GdkEventKey * event, gpointer data) {
    {
        if(entry == user)
            gtk_widget_grab_focus (passwd);
        if(entry == passwd)
            ok_dialog (NULL, NULL);
    }
    return;

}

static const gchar *
passwd_dialog (widgets_t * widgets_p, int caso, const gchar * init_password, const gchar * ptext) {
    GtkWidget *button,
     *hbox,
     *label;
    gboolean user_mapped = FALSE;

    passwd_caso = caso;
    if(init_password) {
        g_free (password);
        password = g_strdup (init_password);
    }

    /*SMBabortdrop=TRUE; */
    dialog = gtk_dialog_new ();

    gtk_window_set_resizable (GTK_WINDOW (dialog), FALSE);
    gtk_container_set_border_width (GTK_CONTAINER (dialog), 5);
    gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);

    gtk_widget_realize (dialog);

    hbox = gtk_hbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);
    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dialog))),
	    hbox, TRUE, TRUE, 0);
    gtk_widget_show (hbox);

        
    if(ptext){
            label = gtk_label_new (ptext);
    } else {
        label = gtk_label_new (_("Supply a username and password below."));
    }

    gtk_box_pack_start (GTK_BOX (hbox), label, EXPAND, FILL, 0);
    gtk_widget_show (label);

    GtkWidget *bhbox=gtk_hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dialog))), 
	    bhbox, TRUE, TRUE, 0);
    gtk_widget_show (bhbox);

    GtkWidget *vbox=gtk_vbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (bhbox), vbox, TRUE, TRUE, 0);
    // put image here
    GdkPixbuf *pixbuf=rfm_get_pixbuf("xffm/stock_dialog-authentication",BIG_ICON_SIZE);
    GtkWidget *image=gtk_image_new_from_pixbuf(pixbuf);
    gtk_box_pack_start (GTK_BOX (vbox), image, TRUE, TRUE, 0);

    gtk_widget_show (image);
    gtk_widget_show (vbox);
    vbox=gtk_vbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (bhbox), vbox, TRUE, TRUE, 0);
    gtk_widget_show (vbox);

 
    hbox = gtk_hbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);
    gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);
    if(caso != 11) {
        user_mapped = TRUE;
        gtk_widget_show (hbox);
    }

    label = gtk_label_new (_("Username:"));
    gtk_box_pack_start (GTK_BOX (hbox), label, NOEXPAND, NOFILL, 0);
    gtk_widget_show (label);

    user = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (hbox), user, EXPAND, NOFILL, 0);
    g_signal_connect (G_OBJECT (user), "activate", G_CALLBACK (entry_activate), NULL);
    gtk_widget_show (user);

    hbox = gtk_hbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);
    gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);
    gtk_widget_show (hbox);

    label = gtk_label_new (_("Password:"));
    gtk_box_pack_start (GTK_BOX (hbox), label, NOEXPAND, NOFILL, 0);
    gtk_widget_show (label);

    passwd = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (hbox), passwd, EXPAND, NOFILL, 0);
    gtk_entry_set_visibility ((GtkEntry *) passwd, FALSE);
    g_signal_connect (G_OBJECT (passwd), "activate", G_CALLBACK (entry_activate), NULL);
    gtk_widget_show (passwd);

    button = rfm_dialog_button ("xffm/stock_ok", _("Ok"));

    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_action_area(GTK_DIALOG(dialog))), button, EXPAND, NOFILL, 0);
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (ok_dialog), (gpointer) ((long)caso));
    button = rfm_dialog_button ("xffm/stock_cancel", _("Cancel"));

    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_action_area(GTK_DIALOG(dialog))), button, EXPAND, NOFILL, 0);
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (cancel_dialog), (gpointer) dialog);
    g_signal_connect (G_OBJECT (dialog), "destroy", G_CALLBACK (destroy_dialog), (gpointer) dialog);
    gtk_widget_show (dialog);

    if(caso != 11 && password) {
        gchar *u,
         *p;
        u = g_strdup (password);
        if(strchr (u, '%')) {
            p = strchr (u, '%') + 1;
            *(strchr (u, '%')) = 0;
        } else
            p = NULL;
        if(strstr (u, "Guest") == NULL && strstr (u, "GUEST") == NULL) {
            if(u && strlen (u)) {
                gtk_entry_set_text ((GtkEntry *) user, u);
            }
            if(p && strlen (p)) {
                gtk_entry_set_text ((GtkEntry *) passwd, p);
            }
        }

        g_free (u);
    }

    if(user_mapped)
        gtk_widget_grab_focus (user);
    else
        gtk_widget_grab_focus (passwd);

    if(widgets_p)
        gtk_window_set_transient_for (GTK_WINDOW (dialog), GTK_WINDOW (widgets_p->window));
    gtk_main ();
    return password;
}
