/*
 * 
 * Copyright 2003-2011 under GNU/GPL v3 or later, which means what it means.
 * Edscott Wilson Garcia 
 *
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#define MAX_LINE_SIZE (_POSIX_PATH_MAX*3)
#define CHILD_FILE_LENGTH 64

#include "rodent_libs.h"
#include "rodent_cpy.i"
/*****************************************************************************/
/**********************     exported symbols     *****************************/
/*****************************************************************************/
// this exported variable is necesary for scp...
//char *src_host = NULL;


gint
rodent_make_overwrite_dialog (widgets_t * widgets_p, const gchar * target, const gchar * src) {
    struct stat st;
    lstat (target, &st);
    gchar *mess;
    gchar *ss1 = rfm_time_to_string (st.st_mtime);
    gchar *ss2 = rfm_sizetag ((off_t) st.st_size, -1);
    if(src) {
        struct stat s_st;
        if(lstat (src, &s_st) < 0) {
            g_warning ("cannot stat %s", src);
        }
        gchar *s1 = rfm_time_to_string (s_st.st_mtime);
        gchar *s2 = rfm_sizetag ((off_t) s_st.st_size, -1);
        gchar *t1 = rfm_utf_string (target);
        gchar *t2 = rfm_utf_string (src); 

        mess = g_strdup_printf ("%s:\n%s\n(%s %s)\n--->\n%s\n(%s %s)",
                _("Overwrite"), 
                t2, s1, s2,
                t1, ss1, ss2);
        g_free (s1);
        g_free (s2);
        g_free (t1);
        g_free (t2);
    } else {
        mess = g_strdup_printf ("%s\n(%s %s)", target, ss1, ss2);
    }

    g_free (ss1);
    g_free (ss2);

    gint result = rfm_confirm (widgets_p, 
	GTK_MESSAGE_WARNING,  
	mess, 
        _("Cancel"), // if NULL, button not shown
	NULL   // if NULL, "Ok" button shown
	);
    g_free(mess);
    return result;
}

gboolean
rodent_cp (int mode, widgets_t * widgets_p, GList * in_list, const gchar * target_path) {
    GSList *verified_list = NULL;
    TRACE ("CPY: rodent_cp\n");
    verify_list (widgets_p, in_list, &verified_list, target_path);
    if(verified_list == NULL) {
        TRACE ("CPY: verified_list == NULL\n");
        return FALSE;
    }

    private_rodent_cp (mode, widgets_p, &verified_list, target_path);
    return TRUE;
}

