/*
 * Copyright (C) 2002-2011 Edscott Wilson Garcia
 * EMail: edscott@xfce.org
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "rodent_libs.h"

#define is_digit(x) ((x)>='0' && (x)<='9')

#include "rodent_remove.i"

GtkWidget *
rodent_create_remove (widgets_t * widgets_p, gchar *text, gchar *message) {
    GtkWidget *vbox2;
    GtkWidget *hbox26;
    GtkWidget *question;
    GtkWidget *vbox12;
    GtkWidget *label16;
    GtkWidget *label20;
    GtkWidget *hbox9;
    GdkPixbuf *pb;

    GtkWidget *dialog = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    // title
    gchar *g=g_strdup_printf("Rodent: %s", _("Remove"));
    gtk_window_set_title (GTK_WINDOW (dialog), g);
    // icon
    gtk_window_set_icon (GTK_WINDOW (dialog),
	    rfm_get_pixbuf("xffm/stock_missing-image", SIZE_ICON));
    //gtk_window_set_modal (GTK_WINDOW (dialog), TRUE);
    g_object_set_data(G_OBJECT(dialog),"widgets_p", widgets_p);

    vbox2 = gtk_vbox_new (FALSE, 0);
    gtk_widget_show (vbox2);
    gtk_container_add (GTK_CONTAINER (dialog), vbox2);

    hbox26 = gtk_hbox_new (FALSE, 0);
    gtk_widget_show (hbox26);
    gtk_box_pack_start (GTK_BOX (vbox2), hbox26, TRUE, TRUE, 0);

    pb = rfm_get_pixbuf ("xffm/stock_dialog-question", SIZE_ICON);
    question = gtk_image_new_from_pixbuf (pb);
    gtk_widget_show (question);
    gtk_box_pack_start (GTK_BOX (hbox26), question, TRUE, TRUE, 0);
    gtk_misc_set_padding (GTK_MISC (question), 5, 0);
    g_object_set_data(G_OBJECT(dialog), "question", question);

/*    pb = rfm_get_pixbuf ("xffm/stock_dialog-warning", SIZE_ICON);
    warning = gtk_image_new_from_pixbuf (pb);
    gtk_widget_show (warning);
    gtk_box_pack_start (GTK_BOX (hbox26), warning, TRUE, TRUE, 0);
    gtk_misc_set_padding (GTK_MISC (warning), 5, 0);
    g_object_set_data(G_OBJECT(dialog), "warning", warning);*/

    vbox12 = gtk_vbox_new (FALSE, 0);
    gtk_widget_show (vbox12);
    gtk_box_pack_start (GTK_BOX (hbox26), vbox12, TRUE, TRUE, 0);

    label16 = gtk_label_new (text);
    gtk_widget_show (label16);
    gtk_box_pack_start (GTK_BOX (vbox12), label16, FALSE, FALSE, 0);

    label20 = gtk_label_new (message);
    gtk_widget_show (label20);
    gtk_box_pack_start (GTK_BOX (vbox12), label20, FALSE, FALSE, 0);

    hbox9 = gtk_hbox_new (FALSE, 0);
    gtk_widget_show (hbox9);
    gtk_box_pack_start (GTK_BOX (vbox12), hbox9, TRUE, TRUE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (hbox9), 5);

    GtkWidget *togglebutton = gtk_check_button_new_with_mnemonic (_("Apply to all"));
    gtk_widget_show (togglebutton);
    gtk_box_pack_start (GTK_BOX (hbox9), togglebutton, FALSE, FALSE, 0);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (togglebutton), TRUE);
    g_object_set_data(G_OBJECT(dialog),"togglebutton", togglebutton);

    GtkWidget *buttonbox = gtk_hbutton_box_new ();
    gtk_widget_show (buttonbox);
    gtk_box_pack_start (GTK_BOX (vbox12), buttonbox, TRUE, TRUE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (buttonbox), 5);
    gtk_button_box_set_layout (GTK_BUTTON_BOX (buttonbox), GTK_BUTTONBOX_END);
    gtk_box_set_spacing (GTK_BOX (buttonbox), 5);

    GtkWidget *button = rfm_dialog_button ("xffm/stock_cancel", _("Cancel"));
    gtk_container_add (GTK_CONTAINER (buttonbox), button);
    g_signal_connect (G_OBJECT (button), "clicked", 
	    G_CALLBACK (apply_action), GINT_TO_POINTER(RM_CANCEL));
    g_object_set_data(G_OBJECT(button), "dialog", dialog);
    g_object_set_data(G_OBJECT(dialog), "cancelbutton", button);

/****************/
#ifdef GNU_SHRED
    button = rfm_dialog_button ("xffm/emblem_no-read", _("Shred"));
    gtk_container_add (GTK_CONTAINER (buttonbox), button);
    g_signal_connect (G_OBJECT (button), "clicked", 
	    G_CALLBACK (apply_action), GINT_TO_POINTER(SHRED_YES));
    g_object_set_data(G_OBJECT(button), "dialog", dialog);
#endif

/****************/

    button = rfm_dialog_button ("xffm/stock_missing-image", _("Remove"));
    gtk_container_add (GTK_CONTAINER (buttonbox), button);
    g_signal_connect (G_OBJECT (button), "clicked", 
	    G_CALLBACK (apply_action), GINT_TO_POINTER(RM_YES));
    g_object_set_data(G_OBJECT(button), "dialog", dialog);


    g_signal_connect (dialog, "delete-event", G_CALLBACK (on_destroy_event), widgets_p);
    g_signal_connect (dialog, "destroy-event", G_CALLBACK (on_destroy_event), widgets_p);


    gtk_widget_realize (dialog);

    gtk_widget_grab_focus (button);



    gtk_widget_show (dialog);

 
    return dialog;
}

// this is the thread function called by the callback,
// and it is consecutively called if "apply to all"
// toggle is unset.
gpointer
rodent_remove (gpointer data) {
    subthread_t *subthread_p=data;
    if(!subthread_p){
        return NULL;
    }
    if(!subthread_p->selection_list) {
	g_free(subthread_p);
	subthread_p=NULL;
        TRACE ("NULL selection list for remove\n");
        return NULL;
    }
    if(g_slist_length(subthread_p->selection_list)==0) {
	g_slist_free(subthread_p->selection_list);
	g_free(subthread_p);
        TRACE ("subthread_p->selection_list)==0 for remove\n");
        return NULL;
    }
    // since this thread is called consecutively, we should 
    // test for widgets_p validity first.
    gboolean valid_widgets=subthread_p->widgets.diagnostics && *(subthread_p->widgets.diagnostics);
    // If test fails, it still could be a DESKVIEW_TYPE
    if (!valid_widgets){
	if (subthread_p->widgets.diagnostics_window) valid_widgets=TRUE;
    }


    if (valid_widgets)
    { 
	make_dialog (subthread_p);
    } else {
	// this is a bit unlikeable, but so it is
	// if widgets_p is no longer valid, silently
	// discard the rest of the delete command 
	GSList *tmp=subthread_p->selection_list;
	for (;tmp && tmp->data; tmp=tmp->next){
	    TRACE("cleanup free %s\n",(gchar *)tmp->data);
	    g_free(data);
	}
	g_slist_free(subthread_p->selection_list);
	g_free(subthread_p);
	subthread_p=NULL;
    }
    
    return NULL;

}

/*
void
rodent_remove (widgets_t * widgets_p, GList * selection_list) {

    GList *remove_list = NULL;
    GList *tmp;

    if(!selection_list) {
        g_warning ("NULL selection list for remove");
        return;
    }

    for(tmp = selection_list; tmp; tmp = tmp->next) {
        record_entry_t *en = rfm_copy_entry ((record_entry_t *) tmp->data);
        remove_list = g_list_append (remove_list, en);
    }
    if(!g_list_length (remove_list)) {
        rfm_status (widgets_p, "xffm/stock_dialog-warning,", strerror (EINVAL), NULL);
        return;
    }

    while(remove_list != NULL && remove_list->data != NULL) {
        TRACE ("REMOVE: remove dialog...\n");
        make_dialog (widgets_p, &remove_list);
    }
    if(remove_list) {
        g_list_free (remove_list);
    }
}
*/
