/*
 * Edscott Wilson Garcia Copyright 2011
 *
 * Copyright (C) 1999 Rasca, Berlin
 * EMail: thron@gmx.de
 *
 * Olivier Fourdan (fourdan@xfce.org)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "rodent_libs.h"
/* this should be first 2 lines after headers: */
G_MODULE_EXPORT LIBRFM_MODULE


G_MODULE_EXPORT
void *
test_gvfs(void *p, void *q){
    DBG("hello world\n");
    GVfs *vfs[2];
    vfs[0] = g_vfs_get_default();
    vfs[1] = g_vfs_get_local();
    gint i;
    DBG("default=0x%x (%d) local=0x%x (%d)\n",
	    GPOINTER_TO_INT(vfs[0]), g_vfs_is_active(vfs[0]),
	    GPOINTER_TO_INT(vfs[1]), g_vfs_is_active(vfs[1]));
    for (i=0; i<2; i++) {
	const gchar * const * types = g_vfs_get_supported_uri_schemes(vfs[i]);
	gchar **p = (gchar **)types;
	for (; p && *p; p++){
	    DBG("%d: %s\n", i, *p);
	}
    }
    return NULL;
}


G_MODULE_EXPORT const gchar *
g_module_check_init (GModule * module) {
#ifdef ENABLE_NLS
    bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
# ifdef HAVE_BIND_TEXTDOMAIN_CODESET
    bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
# endif
    TRACE ("domain=%s", GETTEXT_PACKAGE);
#endif
    return NULL;
}

G_MODULE_EXPORT void *
module_init (void) {
    return NULL;
}

