/*   tubo.h */

/*  A program independent forking object module for gtk based programs.
 *  
 *  Copyright (C) 2000-2005  Edscott Wilson Garcia under GNU GPL
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
/* public stuff */

/* Tubo() returns void pointer to tubo object 
*  usage: see example below */
#include <glib.h>
#include <sys/types.h>
#include <unistd.h>

/**
 * tubo_t:
 *
 **/
#define tubo_t void

int Tubo_id (
    void
);

/**
 * Tubo_threads:
 * @fork_function: Pointer to function to execute after forking.
 * @fork_function_data: Pointer to date to be sent to @fork_function.
 * If these values are NULL, there are ignored.
 * @tubo_done_f: Pointer to function to execute child has exited.
 * @tubo_done_data: Pointer to date to be sent to @tubo_done_f.
 * If these values are NULL, they are ignored.
 * @: Pointer to int to store stdin file descriptor.
 * If this value is NULL, it is ignored.
 * @: Pointer to function to execute with stdout data.
 * @: Pointer to date to be sent to @.
 * If these values are NULL, they are ignored.
 * @: Pointer to function to execute with stderr data.
 * @: Pointer to date to be sent to @.
 * If these values are NULL, they are ignored.

 *
 * @fork_finished_function: Pointer to function to execute when remote 
 * process has terminated.
 * @operate_stdout: Pointer to function to process output produced by 
 * remote process towards stdout. Set to NULL to ignore output.
 * @operate_stderr: Pointer to function to process output produced by 
 * remote process towards stderr. Set to NULL to ignore output.
 * @user_data: Pointer to user_data passed to @fork_finished_function, 
 * @operate_stdin, and @operate_stdout.
 * 
 * Returns: pid of spawned process...
 *
 **/

pid_t Tubo_threads (
    void (*fork_function) (void *),
    void *fork_function_data,
    int *stdin_fd,
    void (*stdout_f) (void *stdout_data,
                      void *stream,
                      int childFD),
    void (*stderr_f) (void *stderr_data,
                      void *stream,
                      int childFD),
    void (*tubo_done_f) (void *),
    void *user_function_data,
    int reap_child,
    gboolean check_valid_ansi_sequence
    );

/***********************************************************/
