/* */
/*  Copyright (C)  1999-2011 Edscott Wilson Garcia under GNU GPL
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
//////    do diff
#define notUNIFIED_DIFF
static gint
configure_event (GtkWidget * widget, GdkEventConfigure * event, gpointer data);

void *
hideshow_menus (gpointer data);

polygon_t *
pushPolygon (diff_t *diff_p, int *top, int *bottom, int *current_line);


void
insert_void (GtkTextBuffer * buffer) {
    GdkColor gray;
    GtkTextIter start,
      end;
    int i;
    char *space = " ";
    GtkTextTag *tag;

    tag = gtk_text_tag_table_lookup (gtk_text_buffer_get_tag_table (buffer), "bg_gray");
    if(!tag) {
        gray.red = gray.green = gray.blue = 0x3fff;
        gtk_text_buffer_create_tag (buffer, "bg_gray", "background_gdk", &gray, NULL);
    }
    gtk_text_buffer_get_iter_at_offset (buffer, &end, 0);
    gtk_text_iter_forward_to_end (&end);
    for(i = 0; i < 255; i++)
        gtk_text_buffer_insert (buffer, &end, space, 1);
    space = "\n";
    gtk_text_buffer_insert (buffer, &end, space, 1);

    start = end;
    gtk_text_iter_backward_chars (&start, 256);
    gtk_text_buffer_apply_tag_by_name (buffer, "bg_gray", &start, &end);
}

static void
_utf8_insert_tag (diff_t *diff_p, GtkTextBuffer * buffer, char *line, char *tag_id, gboolean filename) {
    GtkTextIter end;
    GdkColor fore,
      back;
    GtkTextTag *tag;
    tag = gtk_text_tag_table_lookup (gtk_text_buffer_get_tag_table (buffer), tag_id);
    if(!tag) {
        /*TRACE("dbg:creating tag %s\n",tag_id); */
        if(strcmp (tag_id, "bg_red") == 0) {
            fore.red = fore.green = 0xffff;
            fore.blue = 0;
            back.red = 0xffff;
            back.green = back.blue = 0;
            tag = gtk_text_buffer_create_tag (buffer, tag_id, "background_gdk", &(diff_p->colorbg), "foreground_gdk", &(diff_p->colorfg), NULL);
        } else if(strcmp (tag_id, "bg_blue") == 0) {
            fore.red = fore.green = 0xffff;
            fore.blue = 0;
            back.blue = 0xffff;
            back.green = back.red = 0;
            tag = gtk_text_buffer_create_tag (buffer, tag_id, "background_gdk", &back, "foreground_gdk", &fore, NULL);
        } else if(strcmp (tag_id, "bg_bluewhite") == 0) {
            fore.red = fore.green = fore.blue = 0xffff;
            back.blue = 0xffff;
            back.green = back.red = 0;
            tag = gtk_text_buffer_create_tag (buffer, tag_id, "background_gdk", &back, "foreground_gdk", &fore, NULL);
        }

    }
    gtk_text_buffer_get_iter_at_offset (buffer, &end, 0);
    gtk_text_iter_forward_to_end (&end);

    gchar *q = rfm_utf_string (line);
    gtk_text_buffer_insert_with_tags (buffer, &end, q, -1, tag, NULL);
    g_free (q);
    /*g_free (s);                 */

}

void
utf8_insert_tag (diff_t *diff_p, 
	GtkTextBuffer * buffer, 
	char *line, 
	char *tag_id) {
    _utf8_insert_tag (diff_p, buffer, line, tag_id, FALSE);
}

void
utf8_insert (GtkTextBuffer * buffer, char *line) {
    gchar *q = rfm_utf_string (line);
    gtk_text_buffer_insert_at_cursor (buffer, q, -1);
    g_free (q);
}



static void
advance_buffers (diff_t *diff_p, int *file_line_number, int *file_skiplines) {
    int i;
    char skip_line[256 * 256];
    for(i = 0; i < 2; i++)
        if(diff_p->skip_file[i]) {
            int j;
            /* equal lines */
            for(; diff_p->current_line[i] < diff_p->file_line_number[i] && !feof (diff_p->skip_file[i]); diff_p->current_line[i]++) {
                if(fgets (skip_line, 256 * 256 - 1, diff_p->skip_file[i]) == NULL)
                    g_warning ("fgets:%s", strerror (errno));
                utf8_insert (diff_p->text_buffer[i], skip_line);
                if(i)
                    diff_p->current_buffer_line++;
            }
            /* skip diff sector */
            for(j = 0; j < diff_p->file_skiplines[i] && !feof (diff_p->skip_file[i]); j++) {
                if(fgets (skip_line, 256 * 256 - 1, diff_p->skip_file[i]) == NULL)
                    g_warning ("fgets:%s", strerror (errno));
            }
        }
}

static void
add_different_line (diff_t *diff_p, char *line, int i) {
    diff_p->diff_subsection = TRUE;
    utf8_insert_tag (diff_p, diff_p->text_buffer[i], line, "bg_red");
    diff_p->current_line[i]++;
    diff_p->bottom_bufferline[i]++;
}

static void
add_synchronization_lines (diff_t *diff_p) {
    int i;
    if(diff_p->sync_count == 0)
        return;
    if(diff_p->sync_count < 0) {
        for(i = 0; i > diff_p->sync_count; i--) {
            insert_void (diff_p->text_buffer[1]);
        }
    } else {
        diff_p->current_buffer_line += diff_p->sync_count;
        for(i = 0; i < diff_p->sync_count; i++) {
            insert_void (diff_p->text_buffer[0]);
        }
    }
    diff_p->sync_count = 0;
}

static void
add_previous_polygon (diff_t *diff_p) {
    //widgets_t *widgets_p=&(diff_p->widgets);
    if(!diff_p->polygon_current) {
        int value;
        diff_p->polygon_current = pushPolygon (diff_p, diff_p->top_bufferline, diff_p->bottom_bufferline, diff_p->current_line);
         value = (diff_p->polygon_current->topR < diff_p->polygon_current->topL) ?
	    diff_p->polygon_current->topR : diff_p->polygon_current->topL;
        if(value >= diff_p->lineH)
            value -= diff_p->lineH;
        else
            value = 0;
        gtk_adjustment_set_value (GTK_ADJUSTMENT (diff_p->adj), value);
        configure_event (diff_p->drawA, NULL, diff_p);
#if 0
        gchar *g = g_strdup_printf ("%s %d", ("TRACE diff_p->polygon_current->id:"), diff_p->polygon_current->id);
	rfm_diagnostics(widgets_p, "xffm/apps_diff-tool", " ",g, "\n", NULL);
        g_free (g);
#endif

    } else {
        pushPolygon (diff_p, diff_p->top_bufferline, diff_p->bottom_bufferline, diff_p->current_line);
    }
}


static int
pre_diff (diff_t *diff_p) {
#if 0
    if(!diff_p->left_file) {

        left_filefilename[0] = prompt_path (_(no_left_path), filename[0]);
        if(!filename[0])
            return FALSE;
        fileLD = assign (fileLD, checkdir (filename[0]) ? filename[0] : NULL);
        update_titlesP ();
    }
    if(!filename[1]) {
        filename[1] = prompt_path (_(no_right_path), filename[1]);
        if(!filename[1])
            return FALSE;
        fileRD = assign (fileRD, checkdir (filename[1]) ? filename[1] : NULL);
        update_titlesP ();
    }

    if(!patchO) {               /* not creating a patchfile */
        if(checkdir (filename[0]) && checkdir (filename[1])) {
            /* initialization for globber */
            globber_run ();
        }

        if(checkdir (filename[0]) || checkdir (filename[1])) {
            static char *tmp_c = NULL;
            char *tmp_d;
            /* one of the selections is a directory. Prepare any-diff for the way gnu-diff would react. */
            if(checkdir (filename[0])) {
                tmp_d = strip_it (filename[1], max_strip (filename[1]));
                tmp_c = (char *)malloc (strlen (filename[0]) + strlen (tmp_d) + 2);
                if(!tmp_c)
                    diff_abort (E_MALLOC);
                sprintf (tmp_c, "%s/%s", filename[0], tmp_d);
                if(filename[0])
                    free (filename[0]);
                filename[0] = tmp_c;
                tmp_c = NULL;
            } else {
                tmp_d = strip_it (filename[0], max_strip (filename[0]));
                tmp_c = (char *)malloc (strlen (filename[1]) + strlen (tmp_d) + 2);
                if(!tmp_c)
                    diff_abort (E_MALLOC);
                sprintf (tmp_c, "%s/%s", filename[1], tmp_d);
                if(filename[1])
                    free (filename[1]);
                filename[1] = tmp_c;
                tmp_c = NULL;
            }
            /* now continue using filename[1] and filename[0] gnu-diff interpreted */

        }
        cleanP ();              /* clean difference polygons */
        cleanA ();
        cleanT ();              /* clean display area. */
        update_titlesP ();
        /* Case of void or unreadable files will be dealt with here. */
        if((!checkfile (filename[0])) || (!checkfile (filename[1]))) {
            writeout (text_buffer[0], filename[0]);
            writeout (text_buffer[1], filename[1]);
            return FALSE;
        }
    }
    /* end if !creating patchfile */
    if(!silent) {
        if(currentF)
            show_diag (diff_p, currentF->file);
        else
            show_diag (diff_p, filename[0]);
        show_diag (_(" versus "));
        if(currentF)
            show_diag (diff_p, currentF->newfile);
        else
            show_diag (diff_p, filename[1]);
        show_diag ("diff_p, :\n");
    }
#endif
    return TRUE;
}

/*static void
show_diag (diff_t *diff_p, gchar * message) {
    GtkTextIter start;
    GtkTextIter  end;
    GtkTextMark *mark;
    if((!message) || (!strlen (message)))
        return;

    utf8_insert (diff_p->diagnostics_text, message);
    gtk_text_buffer_get_bounds (diff_p->diagnostics_text, &start, &end);
    mark = 
	gtk_text_buffer_create_mark (diff_p->diagnostics_text, 
		"scrollmark", &end, FALSE);
    gtk_text_view_scroll_to_mark (GTK_TEXT_VIEW (diff_p->view_diag), 
	    mark, 0.2, //gdouble within_margin, 
	    FALSE, 0.0, 0.0);
    gtk_text_buffer_delete_mark (diff_p->diagnostics_text, mark);
    //gdk_flush ();
    return;
}*/


static void
post_diff (diff_t *diff_p) {
    widgets_t *widgets_p=&(diff_p->widgets);
    //if(patchO) return;
    if(!(diff_p->patchmake_flags & SILENT)) {
        if(diff_p->diffC) {           
	    gchar *g =
                g_strdup_printf (
			ngettext("%'u item", "%'u items", diff_p->diffC),
                                 diff_p->diffC);
	    rfm_diagnostics(widgets_p, "xffm/apps_diff-tool", " ", 
		_("Differences"), " ...", g, "\n", NULL);
            g_free (g);
        } else {
	    rfm_diagnostics(widgets_p, "xffm/apps_diff-tool", " ",
	      _("Files are identical\n(or binary files that may or may not differ)"),
	 	"\n",NULL);
        }
    }
}


static void
operate_stdout (void *user_data, void *data, int childFD) {
    diff_t *diff_p=user_data;
    widgets_t *widgets_p=&(diff_p->widgets);
    char *line;

    line = (char *)data;
    TRACE ("Diff: (operate_stdout) %s\n", line);
    if (!line || strlen(line)==0) return;
    if(strncmp (line, "Tubo-id exit:", strlen ("Tubo-id exit:")) == 0) {
            if(strchr (line, '\n')) *strchr (line, '\n') = 0;
GDK_THREADS_ENTER ();
            rfm_diagnostics (widgets_p, "xffm/stock_stop", NULL);
            rfm_diagnostics (widgets_p, "xffm_tag/command_id", strchr (line, ':') + 1, ".", NULL);
            rfm_diagnostics (widgets_p, NULL, "\n", NULL);
GDK_THREADS_LEAVE ();
	    return;
    }
// normal GNU diff output
    const gchar *tag=NULL;
    if (line[0]=='>'){
	tag="xffm_tag/green";
    } else if (line[0]=='<') {
	tag="xffm_tag/red";
    } else if (isdigit(line[0]) || strncmp(line,"---",strlen("---"))==0) {
	tag="xffm_tag/cyan";
    } 

GDK_THREADS_ENTER ();
    rfm_diagnostics(widgets_p,tag, line, NULL);
GDK_THREADS_LEAVE ();
    gchar mode;
    if (isdigit(line[0])) {
	diff_p->diffC++;
GDK_THREADS_ENTER ();
	add_synchronization_lines (diff_p);

        if(diff_p->diff_subsection) {
	    add_previous_polygon (diff_p);
	    configure_event (diff_p->drawA, NULL, diff_p);
	} else {
	    diff_p->diff_subsection=TRUE;
	}
GDK_THREADS_LEAVE ();
	TRACE("got %s\n", line);
	if (strchr(line,'c')){
	    *strchr(line,'c')=0;
	    mode='c';
	} else if (strchr(line,'a')){
	    *strchr(line,'a')=0;
	    mode='a';
	} else if (strchr(line,'d')){
	    *strchr(line,'d')=0;
	    mode='d';
	}
	gchar *left=line;
	gchar *right=line+strlen(line)+1;
	TRACE("mode=%c left=%s right=%s\n", mode, left, right);
	if (strchr(left,',')) {
	    *strchr(left,',')=0;
	    diff_p->file_line_number[0]=atoi(left)-1;
	    left=left+strlen(left)+1;
	    diff_p->file_skiplines[0] = atoi(left)-diff_p->file_line_number[0];
	} else {
	    if (mode=='a') {
		diff_p->file_line_number[0]=atoi(left);
		diff_p->file_skiplines[0] = 0;
	    } else {
		diff_p->file_line_number[0]=atoi(left)-1;
		diff_p->file_skiplines[0] = 1;
	    }
	}
	if (strchr(right,',')) {
	    *strchr(right,',')=0;
	    diff_p->file_line_number[1]=atoi(right)-1;
	    right=right+strlen(right)+1;
	    diff_p->file_skiplines[1] = atoi(right)-diff_p->file_line_number[1];
	} else {
	    if (mode=='d') {
		diff_p->file_line_number[1]=atoi(right);
		diff_p->file_skiplines[1] = 0;
	    } else {
		diff_p->file_line_number[1]=atoi(right)-1;
		diff_p->file_skiplines[1] = 1;
	    }
	}
	gchar *g=g_strdup_printf("--> %d,%d %c %d,%d\n",
		diff_p->file_line_number[0], diff_p->file_skiplines[0],
		mode,
		diff_p->file_line_number[1], diff_p->file_skiplines[1]);
        /*GDK_THREADS_ENTER ();
	rfm_diagnostics(widgets_p, "xffm/apps_diff-tool", g, NULL);
        GDK_THREADS_LEAVE ();*/
	TRACE("%s", g);
	g_free(g);

GDK_THREADS_ENTER ();
        advance_buffers (diff_p, diff_p->file_line_number, diff_p->file_skiplines);
GDK_THREADS_LEAVE ();
	int i; for(i = 0; i < 2; i++) {
	    diff_p->top_bufferline[i] = 
		diff_p->bottom_bufferline[i] = 
		diff_p->current_buffer_line;
	    diff_p->file_skiplines[i] = 0;
	}
        diff_p->diff_section = TRUE;
        return;
   } else if (strncmp(line,"---",strlen("---"))==0) {
   } else {
      switch (line[0]) {
        case '>':
            diff_p->sync_count++;
            GDK_THREADS_ENTER ();
            add_different_line (diff_p, line + 2, 1);
            GDK_THREADS_LEAVE ();
            break;
        case '<':
            diff_p->current_buffer_line++;
            diff_p->sync_count--;
            GDK_THREADS_ENTER ();
            add_different_line (diff_p, line + 2, 0);
            GDK_THREADS_LEAVE ();
            break;
      }
    }

    return;
}


static void
fork_finished_function (void *data) {
    diff_t *diff_p=data;
    if (!diff_p->left_file || !diff_p->right_file) return;
    if (!rfm_g_file_test(diff_p->left_file, G_FILE_TEST_EXISTS)){
	return;
    }
    if (!rfm_g_file_test(diff_p->right_file, G_FILE_TEST_EXISTS)){
	return;
    }
// non unified diff:
GDK_THREADS_ENTER ();
	add_synchronization_lines (diff_p);

        if(diff_p->diff_subsection) {
	    add_previous_polygon (diff_p);
	    configure_event (diff_p->drawA, NULL, diff_p);
	} else {
	    diff_p->diff_subsection=TRUE;
	}
GDK_THREADS_LEAVE ();
    gchar buffer[256*256];
    int i; for(i = 0; i < 2; i++) {
	while (diff_p->skip_file[i] && !feof(diff_p->skip_file[i]) && 
		fgets (buffer, 256 * 256 - 1, diff_p->skip_file[i])){
GDK_THREADS_ENTER ();
	    utf8_insert (diff_p->text_buffer[i], buffer);
GDK_THREADS_LEAVE ();
	    diff_p->current_buffer_line++;   
	}
    }
// this is the same as unified diff:    
GDK_THREADS_ENTER ();
    GtkTextBuffer *text_buffer=
	gtk_text_view_get_buffer (GTK_TEXT_VIEW (diff_p->view_right));
    GtkTextIter start, end;
    gtk_text_buffer_get_bounds (text_buffer, &start, &end);
    GtkTextMark *mark = 
	gtk_text_buffer_create_mark (text_buffer, "scrollmark", &start, FALSE);
    gtk_text_view_scroll_to_mark (GTK_TEXT_VIEW (diff_p->view_right), 
	    mark, 0.2,    /*gdouble within_margin, */
            FALSE, 0.0, 0.0);
    gtk_text_buffer_delete_mark (text_buffer, mark);
    for(i = 0; i < 2; i++) {
        if(diff_p->skip_file[i]) {
            fclose (diff_p->skip_file[i]);
            diff_p->skip_file[i] = NULL;
        }
    }

    configure_event (diff_p->drawA, NULL, diff_p);

    post_diff (diff_p);
    gdk_window_set_cursor (diff_p->window->window, NULL);
    gtk_widget_set_sensitive(diff_p->button_apply, TRUE);
GDK_THREADS_LEAVE ();
    diff_p->diff_flags |= DIFF_IS_DONE;
    diff_p->diff_flags &= (DIFF_RUNNING^0xffffffff);
    g_thread_create (hideshow_menus, data, FALSE, NULL);
}


static void
fork_function (void *data) {
    char **argument = (char **)data;

    execvp (argument[0], argument);
    fprintf (stderr, "CHILD could not execvp: this should not happen\n");
    fprintf (stderr, "Do you have %s in your path?\n", argument[0]);
    fflush (stderr);
    struct timespec thread_wait = {
        0, 100000000
    };
    nanosleep (&thread_wait, NULL);
    _exit (123);
}

static int
do_diff (diff_t *diff_p) {
    widgets_t *widgets_p=&(diff_p->widgets);
    int argc = 0;
    char *arguments[64];
    int i;

    diff_p->diffC = 0; 
    if(!pre_diff (diff_p))  return FALSE;
    diff_p->addedR = diff_p->addedL = 0;
    /* prepare command line */
    arguments[argc++] = "diff";

    gchar *active_left=NULL;
    if (g_file_test(diff_p->left_file, G_FILE_TEST_IS_DIR)) {
	GtkTreeIter iter;
	
	gtk_combo_box_get_active_iter (GTK_COMBO_BOX(diff_p->combo_left), &iter); 
	gtk_tree_model_get (GTK_TREE_MODEL(diff_p->list_store_left), &iter,
	    PATH_COLUMN, &active_left,
	    -1);
    } else {
	active_left = g_strdup(diff_p->left_file);
    }
    gchar *active_right=NULL;
    if (g_file_test(diff_p->right_file, G_FILE_TEST_IS_DIR)) {
	GtkTreeIter iter;

	gtk_combo_box_get_active_iter (GTK_COMBO_BOX(diff_p->combo_right), &iter); 
	gtk_tree_model_get (GTK_TREE_MODEL(diff_p->list_store_right), &iter,
	    PATH_COLUMN, &active_right,
	    -1);
    } else {
	active_right = g_strdup(diff_p->right_file);
    }

    const gchar *diff=" diff ";
    rfm_diagnostics(widgets_p, "xffm/apps_diff-tool",NULL);
    rfm_diagnostics(widgets_p, "xffm_tag/command",diff,
	    active_left, " ",
	    active_right, "\n",NULL);


    arguments[argc++] = active_left;
    arguments[argc++] = active_right;
        

    if (diff_p->diff_flags & IGNORE_CASE) arguments[argc++] = "--ignore-case";
    if (diff_p->diff_flags & IGNORE_TAB_EXPANSION) arguments[argc++] = "--ignore-tab-expansion";
    if (diff_p->diff_flags & IGNORE_SPACE_CHANGE) arguments[argc++] = "--ignore-space-change";
    if (diff_p->diff_flags & IGNORE_ALL_SPACE) arguments[argc++] = "--ignore-all-space";
    if (diff_p->diff_flags & IGNORE_BLANK_LINES) arguments[argc++] = "--ignore-blank-lines";
    if (diff_p->diff_flags & MINIMAL) arguments[argc++] = "--minimal";
    if (diff_p->diff_flags & SPEED_LARGE_FILES) arguments[argc++] = "--speed-large-files";
    if (diff_p->diff_flags & STRIP_TRAILING_CR) arguments[argc++] = "--strip-trailing-cr";
    if (diff_p->diff_flags & EXPAND_TABS) arguments[argc++] = "--expand-tabs";
    if (diff_p->diff_flags & INITIAL_TAB) arguments[argc++] = "--initial-tab";

    arguments[argc++] = (char *)0;

    diff_p->skip_file[0] = fopen (active_left, "r");
    diff_p->skip_file[1] = fopen (active_right, "r");
    
    /* execute... */
    diff_p->diff_subsection=FALSE;
    diff_p->current_buffer_line = 0;
    for(i = 0; i < 2; i++) {
        diff_p->current_line[i] = 
	    diff_p->top_bufferline[i] = 
	    diff_p->bottom_bufferline[i] = 0;
    }
    diff_p->polygon_current = NULL;
    diff_p->diff_section = FALSE;
    diff_p->diff_flags &= (DIFF_IS_DONE^0xffffffff);
    TRACE ("Diff: Tubo_threads\n");
    diff_p->diff_flags |= DIFF_RUNNING;

    static GdkCursor *watch=NULL;
    watch=gdk_cursor_new(GDK_WATCH);
    gdk_window_set_cursor (diff_p->window->window, watch);
    gtk_widget_set_sensitive(diff_p->button_apply, FALSE);
    gchar *current_dir=g_get_current_dir();
    Tubo_threads (fork_function, 
		  (void *)arguments, 
		  NULL,       //stdin fd
                  operate_stdout,       //stdout
                  NULL,         //stderr,
                  fork_finished_function, 
		  diff_p, 
		  TRUE, 
		  FALSE);
    g_free(active_left);
    g_free(active_right);

    if (chdir(current_dir) < 0) {
	g_warning("chdir %s: %s", current_dir, strerror(errno));
    }
    g_free(current_dir);
	   
    return TRUE;
}

#ifdef PATCHMODE
/////   unified diff functions (used for processing patch files) //////
// (currently disabled...)

static void
add_equal_line (diff_t *diff_p, char *line) {
    int i;
    diff_p->diff_subsection = FALSE;
    diff_p->current_buffer_line++;
    for(i = 0; i < 2; i++) {
        diff_p->current_line[i]++;
        diff_p->top_bufferline[i] = diff_p->bottom_bufferline[i] = diff_p->current_buffer_line;
        utf8_insert (diff_p->text_buffer[i], line);
    }
}

static int
get_block_info (diff_t *diff_p, char *line, int *file_line_number, int *file_skiplines) {
    gchar *p;
    int n1, n2, s1, s2;
    if(!line || !strlen (line)) return FALSE;
    if(line[0] != '@' || line[1] != '@') return FALSE;

    p = strtok (line + 2, ",");
    if(!p) return FALSE;
    n1 = 0 - atoi (p);
    n1--;
    p = strtok (NULL, "+");
    if(!p) return FALSE;
    s1 = atoi (p);
    p = strtok (NULL, ",");
    if(!p) return FALSE;
    n2 = atoi (p);
    n2--;
    p = strtok (NULL, "@");
    if(!p) return FALSE;
    s2 = atoi (p);
    diff_p->file_line_number[0] = n1;
    diff_p->file_line_number[1] = n2;
    diff_p->file_skiplines[0] = s1;
    diff_p->file_skiplines[1] = s2;
    /*TRACE("got_block_info: -%d,%d +%d,%d",n1,s1,n2,s2); */
    return TRUE;
}

static void
stdout_unified_diff (void *user_data, void *data, int childFD) {
    diff_t *diff_p=user_data;
    widgets_t *widgets_p=&(diff_p->widgets);
    char *line;

    line = (char *)data;

    TRACE ("Diff: (operate_stdout) %s\n", line);
    if (!line || strlen(line)==0) return;
    if(strncmp (line, "Tubo-id exit:", strlen ("Tubo-id exit:")) == 0) {
            if(strchr (line, '\n')) *strchr (line, '\n') = 0;
GDK_THREADS_ENTER ();
            rfm_diagnostics (widgets_p, "xffm/stock_stop", NULL);
            rfm_diagnostics (widgets_p, "xffm_tag/command_id", strchr (line, ':') + 1, ".", NULL);
            rfm_diagnostics (widgets_p, NULL, "\n", NULL);
GDK_THREADS_LEAVE ();
	    return;
    }
// diff -u output (deprecated, but should still be available for 
// 		   patch files or non GNU diff)	    

    const gchar *tag=NULL;
    if (line[0]=='+'){
	tag="xffm_tag/green";
    } else if (line[0]=='-') {
	tag="xffm_tag/red";
    } else if (line[0]=='@') {
	tag="xffm_tag/cyan";
    } 

            GDK_THREADS_ENTER ();
    rfm_diagnostics(widgets_p,tag, line, NULL);
            GDK_THREADS_LEAVE ();
    switch (line[0]) {
    case '@':
        if(!get_block_info (diff_p, line, diff_p->file_line_number, diff_p->file_skiplines)) {
            GDK_THREADS_ENTER ();
	    rfm_diagnostics(widgets_p, "xffm/apps_diff-tool",  
		    "> error: get_block_info failed...", "\n", NULL);
            GDK_THREADS_LEAVE ();
            return;
        } else {
	    diff_p->diffC++;
#ifdef DEBUG
	    // message for debugging purposes for now...
	   gchar *g = g_strdup_printf ("differences : -%d,%d +%d,%d",
                    diff_p->file_line_number[0], 
		    diff_p->file_skiplines[0],
                    diff_p->file_line_number[1], 
		    diff_p->file_skiplines[1]);
            GDK_THREADS_ENTER ();
	    rfm_diagnostics(widgets_p, "xffm/apps_diff-tool",  " ", g, "\n", NULL);
            GDK_THREADS_LEAVE ();
            g_free (g);
#endif
        }
        GDK_THREADS_ENTER ();
        advance_buffers (diff_p, diff_p->file_line_number, diff_p->file_skiplines);
        GDK_THREADS_LEAVE ();
        diff_p->diff_section = TRUE;
        return;
    default:
        if(!diff_p->diff_section)
            return;
        switch (line[0]) {
        case ' ':
            if(diff_p->diff_subsection) {
                GDK_THREADS_ENTER ();
                add_previous_polygon (diff_p);
                add_synchronization_lines (diff_p);
                configure_event (diff_p->drawA, NULL, diff_p);
                GDK_THREADS_LEAVE ();
                //while (gtk_events_pending()) gtk_main_iteration();
            }
            GDK_THREADS_ENTER ();
            add_equal_line (diff_p, line + 1);
            GDK_THREADS_LEAVE ();
            break;
        case '+':
            diff_p->sync_count++;
            GDK_THREADS_ENTER ();
            add_different_line (diff_p, line + 1, 1);
            GDK_THREADS_LEAVE ();
            break;
        case '-':
            diff_p->current_buffer_line++;
            diff_p->sync_count--;
            GDK_THREADS_ENTER ();
            add_different_line (diff_p, line + 1, 0);
            GDK_THREADS_LEAVE ();
            break;
        }
    }
    return;
}


static void
fork_finished_function_unified_diff (void *data) {
    diff_t *diff_p=data;

GDK_THREADS_ENTER ();
    GtkTextBuffer *text_buffer=
	gtk_text_view_get_buffer (GTK_TEXT_VIEW (diff_p->view_right));
    GtkTextIter start, end;
    gtk_text_buffer_get_bounds (text_buffer, &start, &end);
    GtkTextMark *mark = 
	gtk_text_buffer_create_mark (text_buffer, "scrollmark", &start, FALSE);
    gtk_text_view_scroll_to_mark (GTK_TEXT_VIEW (diff_p->view_right), 
	    mark, 0.2,    /*gdouble within_margin, */
            FALSE, 0.0, 0.0);
    gtk_text_buffer_delete_mark (text_buffer, mark);
GDK_THREADS_LEAVE ();
    diff_p->diff_flags |= DIFF_IS_DONE;
    diff_p->diff_flags &= (DIFF_RUNNING^0xffffffff);
    g_thread_create (hideshow_menus, data, FALSE, NULL);
}
#endif

